## nco 4.7.4

=== CMakeLists.txt ===
#CMake build, Pedro Vicente

#/////////////////////////////////////////////////////////////////////////////////////
#mininum library dependencies: netCDF, HDF5, HDF5_HL, ZLIB (SZIP)
#/////////////////////////////////////////////////////////////////////////////////////

#-DNETCDF_INCLUDE:PATH=<some_path>
#-DNETCDF_LIBRARY:FILE=<some_file>
#-DHDF5_LIBRARY:FILE=<some_file>
#-DHDF5_HL_LIBRARY:FILE=<some_file>
#-DZLIB_LIBRARY:FILE=<some_file>
#-DSZIP_LIBRARY:FILE=<some_file>
#-DCURL_LIBRARY:FILE=<some_file>

#/////////////////////////////////////////////////////////////////////////////////////
#optional library dependencies (Antlr, UDUNITS, EXPAT, GSL)
#/////////////////////////////////////////////////////////////////////////////////////

#-DANTLR_INCLUDE:PATH=<some_path>
#-DANTLR_LIBRARY:FILE=<some_file>
#-DUDUNITS2_INCLUDE:PATH=<some_path>
#-DUDUNITS2_LIBRARY:FILE=<some_file>
#-DEXPAT_LIBRARY:FILE=<some_file>
#-DGSL_INCLUDE:PATH=<some_path>
#-DGSL_LIBRARY:FILE=<some_file>
#-DGSL_CBLAS_LIBRARY:FILE=<some_file>

cmake_minimum_required(VERSION 2.8)
project (nco)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckLibraryExists)

#//////////////////////////
# colorized output
# red, fatal error, cannot build (missing netCDF, HDF5, CURL libraries)
# magenta, "negative" warning (missing optional libraries, GSL, ANTLR, UDUNITS)
# green, "positive" warning (opposite of magenta, optional libraries found)
# blue, general information to take notice (SZIP/ZLIB were detected as needed, special NCO functions are defined)
#//////////////////////////

if(NOT WIN32)
  string(ASCII 27 Esc)
  set(color_reset   "${Esc}[m")
  set(color_magenta "${Esc}[35m")
  set(color_red     "${Esc}[31m")
  set(color_green   "${Esc}[32m")
  set(color_blue    "${Esc}[34m")
endif()

#/////////////////////////////////////////////////////////////////////////////////////
#general C/C++ build flags
#on single-configuration generators (Unix Makefiles, NMake Makefiles) use Debug as default
#on multi-configuration generators (Visual Studio, Xcode) define only 2 types: Debug;Release
#/////////////////////////////////////////////////////////////////////////////////////

set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build.")
if(CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_CONFIGURATION_TYPES "Debug;Release")
endif()

set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build static libs.")
if (NOT BUILD_SHARED_LIBS)
  add_definitions(-DENABLE_STATIC)
endif()

#//////////////////////////
#detect minimum dependencies using
#find_path()
#find_library()
#Notes:
#1) list a static name first to avoid link errors in systems with multiple versions of the same libraries in PATH, used for libz.a
#2) use option NO_SYSTEM_ENVIRONMENT_PATH
#//////////////////////////

set(find_opt NO_SYSTEM_ENVIRONMENT_PATH)

#/////////////////////////////////////////////////////////////////////////////////////
#netCDF
#detect a user defined system environment variable NETCDF_ROOT
#this sets the include path to NETCDF_INCLUDE directly
#and a PATHS hint for NETCDF_LIBRARY (because the library name can be any legal combination of "netcdf" )
#For this case find_library(NETCDF_LIBRARY) MUST be called 2 times
#First time it looks in NETCDF_LIBRARY_PATH if set, avoiding all other PATHS with NO_DEFAULT_PATH
#If not found, business as usual
#//////////////////////////

# NETCDF_ROOT, if found in environment, will be searched after specific command line locations for NETCDF_INCLUDE
# and NETCDF_LIBRARY
set(netcdf_root "$ENV{NETCDF_ROOT}")
if(netcdf_root)
  message("${color_blue}-- Using user-defined netCDF root location: ${netcdf_root}${color_reset}")
endif()

#//////////////////////////
#a user defined -DNETCDF_INCLUDE was specified; check if it really exists :-)
#//////////////////////////

if(NETCDF_INCLUDE)
  if(EXISTS "${NETCDF_INCLUDE}/netcdf.h")
    message("-- Using ${NETCDF_INCLUDE}/netcdf.h")
  else()
    if(netcdf_root)
        set(NETCDF_INCLUDE "${netcdf_root}/include")
    endif()
    if(EXISTS "${NETCDF_INCLUDE}/netcdf.h")
      message("-- Using ${NETCDF_INCLUDE}/netcdf.h")
    else()
      message(FATAL_ERROR "${color_red}netcdf.h not found at ${NETCDF_INCLUDE}${color_reset}")
    endif()
  endif()
endif()

find_path(NETCDF_INCLUDE netcdf.h ${find_opt})
if(NOT NETCDF_INCLUDE)
  message(FATAL_ERROR "${color_red}netcdf.h header file not found${color_reset}")
else()
  message("-- Found netcdf.h header file at: " ${NETCDF_INCLUDE})
endif()

#//////////////////////////
#a user defined -DNETCDF_LIBRARY was specified; check if it really exists :-)
#//////////////////////////

if(NETCDF_LIBRARY)
  if(EXISTS "${NETCDF_LIBRARY}")
    message("-- Using ${NETCDF_LIBRARY}")
  else()
    if(netcdf_root)
        set(NETCDF_LIBRARY_PATH "${netcdf_root}/lib")
    else()
        message(FATAL_ERROR "${color_red}Specified ${NETCDF_LIBRARY} does not exist${color_reset}")
    endif()
  endif()
endif()

find_library(NETCDF_LIBRARY NAMES netcdf PATHS ${NETCDF_LIBRARY_PATH} NO_DEFAULT_PATH)
find_library(NETCDF_LIBRARY NAMES netcdf ${find_opt})
if(NOT NETCDF_LIBRARY)
  message(FATAL_ERROR "${color_red}netcdf library not found${color_reset}")
else()
  message("-- Found netcdf library at: " ${NETCDF_LIBRARY})
endif()

#/////////////////////////////////////////////////////////////////////////////////////
#netCDF
#Check for several functions in the netCDF library; define C macro accordingly
#CMAKE_REQUIRED_LIBRARIES needs NETCDF_LIBRARY
#check for header file netcdf_mem.h existence
#/////////////////////////////////////////////////////////////////////////////////////

set(CMAKE_REQUIRED_LIBRARIES ${NETCDF_LIBRARY})

check_library_exists(${NETCDF_LIBRARY} nc_inq_path "" has_nc_inq_path)
if (has_nc_inq_path)
  message("-- Found nc_inq_path in: " ${NETCDF_LIBRARY})
  add_definitions(-DHAVE_NC_INQ_PATH)
endif()

check_library_exists(${NETCDF_LIBRARY} nc_inq_format "" has_nc_inq_format)
if (has_nc_inq_format)
  message("-- Found nc_inq_format in: " ${NETCDF_LIBRARY})
  add_definitions(-DHAVE_NC_INQ_FORMAT)
endif()

#/////////////////////////////////////////////////////////////////////////////////////
#netCDF 4.6.0 
#nc_def_var_filter , has_inq_var_filter, define NC_LIB_VERSION=460 if both found 
#/////////////////////////////////////////////////////////////////////////////////////

check_library_exists(${NETCDF_LIBRARY} nc_def_var_filter "" has_nc_def_var_filter)
if (has_nc_def_var_filter)
  message("-- Found nc_def_var_filter in: " ${NETCDF_LIBRARY})
  add_definitions(-DHAVE_NC_DEF_VAR_FILTER)
endif()

check_library_exists(${NETCDF_LIBRARY} nc_inq_var_filter "" has_inq_var_filter)
if (has_inq_var_filter)
  message("-- Found has_inq_var_filter in: " ${NETCDF_LIBRARY})
  add_definitions(-DHAVE_NC_INQ_VAR_FILTER)
endif()

if (has_nc_def_var_filter AND has_inq_var_filter)
  add_definitions(-DNC_LIB_VERSION=460)
endif ()

find_path(path_netcdf_mem_h netcdf_mem.h PATHS ${NETCDF_INCLUDE})
if (path_netcdf_mem_h)
  message("-- Found netcdf_mem.h in: " ${path_netcdf_mem_h})
endif()

check_library_exists(${NETCDF_LIBRARY} nc_open_mem "" has_nc_open_mem)
if (has_nc_open_mem)
  message("-- Found nc_open_mem in: " ${NETCDF_LIBRARY})
endif()

if (has_nc_open_mem AND path_netcdf_mem_h)
  add_definitions(-DHAVE_NETCDF_MEM_H)
  message("-- NetCDF diskless functionaliy enabled")
else()
  message("-- NetCDF diskless functionaliy not available, netcdf_mem.h or nc_open_mem not found")
endif()



#/////////////////////////////////////////////////////////////////////////////////////
#HDF5
#/////////////////////////////////////////////////////////////////////////////////////


find_library(HDF5_LIBRARY NAMES hdf5 PATHS "/usr/lib/x86_64-linux-gnu/hdf5/serial")
if(NOT HDF5_LIBRARY)
  message(FATAL_ERROR "${color_red}hdf5 library not found${color_reset}")
else()
  message("-- Found hdf5 library at: " ${HDF5_LIBRARY})
endif()

find_library(HDF5_HL_LIBRARY NAMES hdf5_hl PATHS "/usr/lib/x86_64-linux-gnu/hdf5/serial")
if(NOT HDF5_HL_LIBRARY)
  message(FATAL_ERROR "${color_red}hdf5 high level library not found${color_reset}")
else()
  message("-- Found hdf5 high level library at: " ${HDF5_HL_LIBRARY})
endif()

#//////////////////////////
#HDF5 can be optionally linked with the SZIP library (Science Data Lossless Compression Program) and ZLIB
#Symbol to detect in ZLIB can be only H5Z_DEFLATE, a structure only defined in H5Zdeflate.c if the filter is enabled
#For SZIP the structure can be only H5Z_SZIP, defined in H5Zszip.c if the filter is enabled
#check_library_exists() tries to link a temporary program with these symbols
#On MSVC for this detection to work, the HDF5 library MUST HAVE as additional dependencies the ZLIB and SZIP libraries,
#which is not a requirement for the library to build successfully
#//////////////////////////

set(CMAKE_REQUIRED_LIBRARIES ${HDF5_LIBRARY})

message("-- Detecting if HDF5 library ${HDF5_LIBRARY} needs the ZLIB library...")
check_library_exists(${HDF5_LIBRARY} H5Z_DEFLATE "" NEED_ZLIB)
if (NEED_ZLIB)
  message("${color_blue}-- ZLIB library is needed...${color_reset}")
else()
  message("${color_blue}-- ZLIB library is not needed...${color_reset}")
endif()

message("-- Detecting if HDF5 library ${HDF5_LIBRARY} needs the SZIP library...")
check_library_exists(${HDF5_LIBRARY} H5Z_SZIP "" NEED_SZIP)
if (NEED_SZIP)
  message("${color_blue}-- SZIP library is needed...${color_reset}")
else()
  message("${color_blue}-- SZIP library is not needed...${color_reset}")
endif()

if (NEED_SZIP)
  message("-- Trying to find the SZIP library...")
  find_library(SZIP_LIBRARY NAMES sz ${find_opt})
  if(NOT SZIP_LIBRARY)
    message(FATAL_ERROR "${color_red}szip library not found${color_reset}")
  else()
    message("-- Found szip library at: " ${SZIP_LIBRARY})
  endif()
endif()

if (NEED_ZLIB)
  message("-- Trying to find the ZLIB library...")
  find_library(ZLIB_LIBRARY NAMES libz.a z ${find_opt})
  if(NOT ZLIB_LIBRARY)
    message(FATAL_ERROR "${color_red}zlib library not found${color_reset}")
  else()
    message("-- Found zlib library at: " ${ZLIB_LIBRARY})
  endif()
endif()

find_library(CURL_LIBRARY NAMES curl ${find_opt})
if(NOT CURL_LIBRARY)
  message(FATAL_ERROR "${color_red}curl library not found${color_reset}")
else()
  message("-- Found curl library at: " ${CURL_LIBRARY})
endif()

#//////////////////////////
#detect optional dependencies
#//////////////////////////

#//////////////////////////
# UDUNITS2 (and EXPAT)
# Add non standard UDUNITS2 header paths (Mac ports, Linux Fedora)
#//////////////////////////

set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH})
set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} "/opt/local/include/udunits2")
set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} "/usr/include/udunits2")

find_path(UDUNITS2_INCLUDE udunits2.h ${find_opt})
if(NOT UDUNITS2_INCLUDE)
  message("${color_magenta}-- Unidata units library header files not found${color_reset}")
else()
  message("-- Found Unidata units library header files at: " ${UDUNITS2_INCLUDE})
endif()

find_library(UDUNITS2_LIBRARY NAMES udunits2 ${find_opt})
if(NOT UDUNITS2_LIBRARY)
  message("${color_magenta}-- Unidata units library not found${color_reset}")
else()
  message("-- Found Unidata units library at: " ${UDUNITS2_LIBRARY})
endif()

#//////////////////////////
# UDUnits depends on expat
#//////////////////////////

if (UDUNITS2_LIBRARY AND UDUNITS2_INCLUDE)
  find_library(EXPAT_LIBRARY NAMES libexpatMT expat ${find_opt})
  if(NOT EXPAT_LIBRARY)
    message("${color_magenta}-- Expat library not found${color_reset}")
    message("-- Disabling UDUNITS support")
  else()
    message("-- Found Expat library at: " ${EXPAT_LIBRARY})
    message("${color_green}-- Building with UDUNITS support${color_reset}")
  endif()
endif()

#//////////////////////////
#compile as C++/static CRT on Visual Studio and as C99 on UNIX
#//////////////////////////

if (MSVC)
  set(MSVC_USE_STATIC_CRT ON CACHE BOOL "Use /MT flag (static CRT) when compiling in MSVC")
  if (MSVC_USE_STATIC_CRT)

=== bld/Makefile ===
# $Header$ -*-makefile-*-

# Purpose: GNU Makefile for NCO module nco
# Requires GNU Make---AT&T Make chokes on GNU syntax

# Copyright (C) 1994--2018 Charlie Zender
# License: GNU General Public License (GPL) Version 3
# See http://www.gnu.org/copyleft/gpl.html for full license text

# Quickie test copies:
# scp ~/nco/bld/Makefile dust.ess.uci.edu:nco/bld
# scp ~/nco/bld/Makefile gplogin2.ps.uci.edu:nco/bld
# scp ~/nco/bld/Makefile skyglow.ess.uci.edu:nco/bld

# Machine build parameters
#                         Source     Method   Packages Compiler
# aerosol.ess.uci.edu: NCO          Configure All else clang
# AppVeyor CI        : NCO          CMake     All else MSVC
# cheyenne.ucar.edu  : NCO          Makefile  All else Intel
# cooley.alcf.anl.g  : NCO          Configure All else GCC
# edison.nersc.gov   : NCO          Configure All else Intel
# firn.ess.uci.edu   : NCO          Configure All else clang
# frazil.ess.uci.edu : NCO          Configure All else clang
# glace.ess.uci.edu  : NCO          CMake     All else GCC
# grele.ess.uci.edu  : NCO          Makefile  All else GCC
# katabatic.ess.uci.e: NCO          CMake     All else clang
# rhea.ccs.ornl.gov  : NCO          Makefile  All else GCC
# skyglow.ess.uci.edu: NCO + netCDF Configure All else GCC
# Travis CI          : NCO          Configure All else gcc,clang,g++

# Usage (testing):
# make tst                           # Vanilla regression test
# make FL_FMT=netcdf4 tst            # netCDF4 regression test
# make MPI_PRC=3 tst                 # MPI regression test
# make MPI_PRC=3 bm                  # MPI benchmarks
# make THR_NBR=2 tst                 # OpenMP regression test
# make THR_NBR=2 bm                  # OpenMP benchmarks
# make MPI=Y                         # MPI features (HDF5 and PnetCDF I/O)
# make NETCDF4=Y                     # netCDF4 features
# make PNETCDF=Y                     # PnetCDF features

# Usage (Compilation):
# cd ~/nco/qt;qmake;make;cd -        # Qt
# cd ~/nco/bld;make;cd -             # Default build
# cd ~/nco/bld;make USR_TKN='-DNC_HAVE_RENAME_GRP';cd - # New API
# cd ~/nco/bld;make UDUNITS_INC='/usr/include/udunits2';cd - # Fedora build
# cd ~/nco/bld;make cln bin_cln;cd - # Clean all dependencies for fresh build
# cd ~/nco/bld;make dir all; cd -    # Create target directories then build
# cd ~/nco/bld;make dbg;cd -         # Print make diagnostics
# cd ~/nco/bld;make DPKG=Y;cd -      # Debian hardening
# cd ~/nco/bld;make ESMF=Y;cd -      # ESMF regridding
# cd ~/nco/bld;make GSL=Y;cd -	     # GSL support
# cd ~/nco/bld;make I18N=Y;cd -      # Internationalization
# cd ~/nco/bld;make lib_cln;cd -     # Clean libraries
# cd ~/nco/bld;make MPI=Y;cd -       # MPI support
# cd ~/nco/bld;make MPI_FAKE=Y;cd -  # Spoof MPI support
# cd ~/nco/bld;make OMP=Y;cd -       # OpenMP support
# cd ~/nco/bld;make OPTS=D;cd -      # "Debugging": Enough symbols for debugging (default)
# cd ~/nco/bld;make OPTS=O;cd -      # "Optimize": For production (includes symbols)
# cd ~/nco/bld;make OPTS=R;cd -      # "Regular": No optimization or debugging
# cd ~/nco/bld;make OPTS=X;cd -      # "eXtreme": All debugging switches available
# cd ~/nco/bld;make sys;cd -         # Install in /usr/local (must sudo)
# cd ~/nco/bld;make SZ=Y;cd -	     # Szip support
# cd ~/nco/bld;make UDUNITS=Y;cd -   # UDUnits support
# cd ~/nco/bld;make --jobs=4;cd -    # Parallel make
# Normal (Linux) developer systems:
# cd ~/nco/bld;make cln all ncap2;cd - # New default for most machines
# cd ~/nco/bld;make OMP=Y CUDA=Y OPTS=D NETCDF4=Y UDUNITS=Y allinone;cd - # givre
# cd ~/nco/bld;make OMP=Y OPTS=D NETCDF4=Y UDUNITS=Y allinone;cd - # givre, neige
# cd ~/nco/bld;make OMP=Y OPTS=D NETCDF4=N UDUNITS=Y allinone;cd - # glace, virga
# mpi-selector --set openmpi_gcc-1.3.3 # Then use /sopt/netcdf/netcdf3-gcc-serial serial libraries
# mpi-selector --set mpich_pgi_1.2.7p1 # After compiling
# cd ~/nco/bld;ANTLR_ROOT=/sopt/gfortran_g++ NETCDF_ROOT=/sopt/gfortran_g++ SZ_LIB=/sopt/lib UDUNITS_INC=/sopt/include UDUNITS_LIB=/sopt/lib make OMP=Y OPTS=D NETCDF4=Y SZ=Y UDUNITS=N allinone;cd - # greenplanet gcc
# cd ~/nco/bld;ANTLR=/home/pvicente/install/antlr-2.7.7/bin/antlr ANTLR_ROOT=/home/pvicente/install/antlr-2.7.7 NETCDF_ROOT=/home/pvicente/install/netcdf-4.3.0 UDUNITS_INC=/home/pvicente/install/udunits-2.1.24/include UDUNITS_LIB=/home/pvicente/install/udunits-2.1.24/lib make OPTS=D allinone;cd - # greenplanet gcc pedro
# cd ~/nco/bld;ANTLR=/sopt/ifort_icpc/bin/antlr ANTLR_ROOT=/sopt/ifort_icpc SZ_LIB=/sopt/lib UDUNITS_INC=/sopt/include UDUNITS_LIB=/sopt/lib make OMP=Y OPTS=D NETCDF4=Y SZ=Y UDUNITS=N allinone;cd - # greenplanet intel
# cd ~/nco/bld;ANTLR=/sopt/pgf90_pgcc/bin/antlr ANTLR_ROOT=/sopt/pgf90_pgcc SZ_LIB=/sopt/lib UDUNITS_INC=/sopt/include UDUNITS_LIB=/sopt/lib make OMP=Y OPTS=D NETCDF4=N SZ=Y UDUNITS=N allinone;cd - # greenplanet pgi
# cd ~/nco/bld;make OMP=Y OPTS=D NETCDF4=N UDUNITS=Y allinone;cd - # pbs
# cd ~/nco/bld;make OMP=Y OPTS=D UDUNITS=Y UBUNTU_440=Y allinone # grele
# cd ~/nco/bld;make NETCDF4=N all ncap2;cd - # tephra
# cd ~/nco/bld;make OMP=Y OPTS=D NETCDF4=N UDUNITS=N allinone;cd - # silt, clay
# cd ~/nco/bld;NETCDF_INC='/usr/include/netcdf-3' NETCDF_LIB='/usr/lib64' make GSL=N OMP=N OPTS=D NETCDF4=N UDUNITS=N allinone;cd - # snow
# cd ~/nco/bld;make OMP=N OPTS=D NETCDF4=N UDUNITS=N USR_TKN='-DNEED_NC_INQ_FORMAT' allinone;cd - # snow w/OPeNDAP
# cd ~/nco/bld;make OPTS=D USR_TKN='-DNEED_NC_INQ_FORMAT' allinone;cd -
# 64-bit ABI on UCI MPC:
# cd ~/nco/bld;env ANTLR='/software/antlr/bin/antlr' ANTLR_ROOT='/software/antlr' UDUNITS_INC='/software/udunits/include' UDUNITS_LIB='/software/udunits/lib' make --jobs=1 ABI=64 allinone;cd -
# 64-bit ABI on UCI IPCC:
# cd ~/nco/bld;env ANTLR='/usr/local/pgi/bin/antlr' ANTLR_ROOT='/usr/local/pgi' make --jobs=1 ABI=64 allinone;cd -
# 64-bit ABI netCDF3 on NCAR AIX systems (bluefire):
# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' NETCDF_LIB='/usr/local/lib64/r4i4' UDUNITS_INC='/contrib/udunits-1.12.9/include' UDUNITS_LIB='/contrib/udunits-1.12.9/lib' make --jobs=1 OPTS=D NETCDF4=N UDUNITS=N allinone ABI=64;cd -
# 64-bit ABI netCDF4 on NCAR AIX systems (bluefire):
# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' CURL_LIB='/contrib/curl/7.21.2/lib' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' HDF5_ROOT='/contrib/hdf5-1.8.7_seq' LDFLAGS='-lnetcdf -lhdf5_hl -lhdf5 -lz' NETCDF_ROOT='/contrib/netcdf/4.1.3_seq' SZ_LIB='/contrib/szip/lib' UDUNITS_LIB='/contrib/zlib/lib' make --jobs=1 OPTS=D SZ=Y allinone ABI=64;cd -
# 64-bit ABI netCDF4 on NCAR AIX systems (bluefire):
# cd ~/bin/AIX;/usr/local/bin/tar cvzf ~/nco-4.4.6.aix53.tar.gz nc*;scp ~/nco-4.4.6.aix53.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
# netCDF4 on NCAR Linux cluster systems (mirage):
# cd ~/nco/bld;make OPTS=D allinone;cd -
# netCDF4 on ORNL Linux cluster systems (titan, rhea.ccs.ornl.gov):
# module avail
# . ~/.bashrc
# module add intel gsl
# export LD_LIBRARY_PATH='/sw/redhat6/netcdf/4.1.3/rhel6.4_intel13.1.3/lib:/sw/redhat6/szip/2.1/rhel6.6_gnu4.8.2/lib':${LD_LIBRARY_PATH}
# export NETCDF_ROOT='/sw/redhat6/netcdf/4.1.3/rhel6.4_intel13.1.3' 
# export PATH='/sw/redhat6/netcdf/4.1.3/rhel6.4_intel13.1.3/bin':${PATH}
# cd ~/nco/bld;make ANTLR_ROOT=${HOME} NETCDF_ROOT='/sw/redhat6/netcdf/4.1.3/rhel6.4_intel13.1.3' SZ=Y SZ_LIB='/sw/redhat6/szip/2.1/rhel6.6_gnu4.8.2/lib' UDUNITS_INC='/sw/redhat6/udunits/2.1.24/rhel6.4_intel13.1.3/include' UDUNITS_LIB='/sw/redhat6/udunits/2.1.24/rhel6.4_intel13.1.3/lib' OPTS=D allinone;cd -
# ncap2:
# netCDF4 on NCAR Linux cluster systems (yellowstone):
# /ncar/opt/hpss/hsi # Starts HPSS session
# export PATH=${PATH}\:/ncar/opt/hpss
# GNU (works):
# module swap intel gnu;module add gsl;module add netcdf/4.3.0;
# export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}\:/glade/apps/opt/udunits/2.1.24/gnu/default/lib
# cd ~/nco/bld;make NETCDF_ROOT='/glade/apps/opt/netcdf/4.3.0/gnu/default' UDUNITS_INC='/glade/apps/opt/udunits/2.1.24/gnu/default/include' UDUNITS_LIB='/glade/apps/opt/udunits/2.1.24/gnu/default/lib' OPTS=D allinone;cd -
# Intel (works as of 20140129):
# module add intel;module add gsl;module add netcdf/4.3.0;
# https://www2.cisl.ucar.edu/sites/default/files/Yellowstone_Started_Nov30-2.pdf
# module add pnetcdf/1.4.1
# export PATH=${PATH}:/glade/apps/opt/netcdf/4.3.0/intel/12.1.5/bin # needed for ncgen
# export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:/glade/apps/opt/netcdf/4.3.0/intel/12.1.5/lib # needed to run NCO
# cd ~/nco/bld;make NETCDF_ROOT='/glade/apps/opt/netcdf/4.3.0/intel/default' UDUNITS_INC='/glade/apps/opt/udunits/2.1.24/intel/12.1.4/include' UDUNITS_LIB='/glade/apps/opt/udunits/2.1.24/intel/12.1.4/lib' OPTS=D allinone;cd -
# Cygwin on Windows Vista systems:
# cd ~/nco/bld;ANTLR='antlr' make --jobs=1 GSL=Y OPTS=D NETCDF4=Y UDUNITS=Y allinone;cd -
# cd ~/bin/WIN32;tar cvzf ~/nco-4.5.2.win32.cygwin.tar.gz nc* ; scp ~/nco-4.5.2.win32.cygwin.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
# Data files to dust
# cd ~/nco/data;scp cmip5.nc obs.nc mdl_1.nc mdl_2.nc in_grp*.nc in.nc in_4c.nc dust.ess.uci.edu:/var/www/html/nco

# Top-level tokens defining directory structure
# These tokens may be over-ridden by environment variables or when invoking make, e.g., make OMP=Y
MY_BLD_DIR := ../bld
ifndef PVM_ARCH
 PVM_ARCH := $(shell ${MY_BLD_DIR}/pvmgetarch)
endif
ifndef MY_BIN_DIR
 MY_BIN_DIR := ../bin
endif
ifndef MY_LIB_DIR
 MY_LIB_DIR := ../lib
endif
ifndef MY_MAN_DIR
 MY_MAN_DIR := ../man
endif
ifndef MY_OBJ_DIR
 MY_OBJ_DIR := ../obj
endif
MY_BM_DIR := ../bm
MY_DAT_DIR := ../data
MY_DBN_DIR := ../debian
MY_DOC_DIR := ../doc
MY_DPN_DIR := ${MY_OBJ_DIR}
MY_SRC_DIR := ../src/nco
MY_INC_DIR := ${MY_SRC_DIR}
NCO_CXX_SRC_DIR := ${MY_SRC_DIR}/../nco_c++
NCOXX_SRC_DIR := ${MY_SRC_DIR}/../nco++

# Primary tokens which determine build options
# Specify non-default when invoking make, e.g. make OMP=Y
ifndef ABI
# 32- vs. 64-bit ABI: 32=32-bit mode, 64=64-bit mode (default) if available
 ABI := 64
endif # endif ABI
ifndef CCACHE
 CCACHE := N
endif # CCACHE
ifndef CNK
# Use newer netCDF4.1 chunking API
 CNK := Y
endif # endif CNK
ifndef CUDA
 CUDA := N
endif # CUDA
ifndef DAP
 DAP := Y
endif # DAP
ifndef DBG
# Debugging token N=No (default) Y=Yes
 DBG := N
endif # endif DBG
ifndef DPKG
# Debian hardening tokens
 DPKG := N
endif # endif DPKG
ifdef FL_FMT
# Pass this netCDF4 argument to nco_bm.pl
 FL_FMT_SNG := "--fl_fmt=${FL_FMT}"
else # endif FL_FMT
 FL_FMT_SNG :=
endif # endif FL_FMT
ifndef GCC_RCH_ARG
 GCC_RCH_ARG :=
endif # endif GCC_RCH_ARG
ifndef GSL
# Use GSL functionality
 GSL := Y
endif # endif GSL
ifndef ICC_RCH_ARG
 ICC_RCH_ARG :=
endif # endif ICC_RCH_ARG
ifndef I18N
 I18N := N
endif
ifndef NCO_YY_PFX
 NCO_YY_PFX := nco_yy
endif
ifndef MK_DPN
 MK_DPN = ${CPP} -M # NB: Recursive expansion required
 MK_DPN_CXX = ${CXX} -M # NB: Recursive expansion required
endif # endif MK_DPN
ifndef MPI # MPI
 MPI := N
endif # endif MPI
ifndef MPI_FAKE # MPI
 MPI_FAKE := N
endif # endif MPI_FAKE
ifndef NCO_BUILDENGINE
 NCO_BUILDENGINE := Traditional \(nco/bld/Makefile\)
endif # NCO_BUILDENGINE
ifndef NCO_VRS
# Used for RPM building
 NCO_VRS := $(shell cat ${MY_DOC_DIR}/VERSION)
endif
ifndef NETCDF4 # netCDF4 support
 NETCDF4 := Y
endif # endif NETCDF4
ifndef NETCDF_ROOT
 NETCDF_ROOT := /usr/local
endif
ifndef NETCDF4_ROOT
 NETCDF4_ROOT := ${NETCDF_ROOT}
endif
ifndef NETCDF_INC
ifdef INC_NCAR
 NETCDF_INC := ${INC_NCAR} # NCAR module path
else # endelse INC_NCAR
 NETCDF_INC := ${NETCDF_ROOT}/include # Directory containing netcdf.h
endif # endif INC_NCAR
endif # endif NETCDF_INC
ifndef NETCDF_LIB
ifdef LIB_NCAR
 NETCDF_LIB := ${LIB_NCAR} # NCAR module path
else # endelse LIB_NCAR
 NETCDF_LIB := ${NETCDF_ROOT}/lib # Directory containing libnetcdf.a
endif # endif LIB_NCAR
endif # endif NETCDF_LIB

=== debian/changelog ===
nco (4.7.4-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 13 Apr 2018 07:14:05 +0200

nco (4.7.4-1) unstable; urgency=medium

  * New upstream release.
  * Update Vcs-* URLs for Salsa.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 07 Apr 2018 16:02:48 +0200

=== debian/control ===
Source: nco
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               autotools-dev,
               bison,
               flex,
               antlr,
               libantlr-dev,
               gsl-bin,
               libgsl-dev,
               netcdf-bin,
               libnetcdf-dev,
               libudunits2-dev,
               libdap-dev,
               texinfo
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.gi -b stretch-backportst
Homepage: http://nco.sourceforge.net/

Package: nco
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Command-line operators to analyze netCDF files
 NCO is a suite of programs known as operators. The operators are stand-alone,
 command-line programs executable in a POSIX shell. Operators take one or more
 netCDF files as input, perform operations (e.g., averaging, hyperslabbing),
 and produce a netCDF output file. NCO was originally designed to manipulate and
 analyze climate data, though it works on any netCDF format datasets.

## nco 4.7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -201,7 +201,13 @@
   message("-- NetCDF diskless functionaliy not available, netcdf_mem.h or nc_open_mem not found")
 endif()
 
-
+#if nc_def_var_filter() is available, nc_inq_path(), nc_inq_format() and has_nc_open_mem() are too
+if (has_nc_def_var_filter)
+  message("-- Defining HAVE_NC_INQ_PATH, HAVE_NC_INQ_FORMAT, HAVE_NETCDF_MEM_H")
+  add_definitions(-DHAVE_NC_INQ_PATH)
+  add_definitions(-DHAVE_NC_INQ_FORMAT)
+  add_definitions(-DHAVE_NETCDF_MEM_H)
+endif()
 
 #/////////////////////////////////////////////////////////////////////////////////////
 #HDF5
@@ -314,14 +320,3 @@
     message("-- Disabling UDUNITS support")
   else()
     message("-- Found Expat library at: " ${EXPAT_LIBRARY})
-    message("${color_green}-- Building with UDUNITS support${color_reset}")
-  endif()
-endif()
-
-#//////////////////////////
-#compile as C++/static CRT on Visual Studio and as C99 on UNIX
-#//////////////////////////
-
-if (MSVC)
-  set(MSVC_USE_STATIC_CRT ON CACHE BOOL "Use /MT flag (static CRT) when compiling in MSVC")
-  if (MSVC_USE_STATIC_CRT)

=== debian/changelog ===
nco (4.7.5-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Jul 2018 16:28:26 +0200

nco (4.7.5-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.4, no changes.
  * Strip trailing whitespace from control & rules files.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 11 Jun 2018 07:38:34 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
 Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.gi -b stretch-backportst
 Homepage: http://nco.sourceforge.net/
@@ -33,4 +33,3 @@
  netCDF files as input, perform operations (e.g., averaging, hyperslabbing),
  and produce a netCDF output file. NCO was originally designed to manipulate and
  analyze climate data, though it works on any netCDF format datasets.
-

## nco 4.7.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -151,6 +151,12 @@
 
 set(CMAKE_REQUIRED_LIBRARIES ${NETCDF_LIBRARY})
 
+check_library_exists(${NETCDF_LIBRARY} nc_rename_grp "" has_nc_rename_grp)
+if (has_nc_rename_grp)
+  message("-- Found nc_rename_grp in: " ${NETCDF_LIBRARY})
+  add_definitions(-DHAVE_NC_RENAME_GRP)
+endif()
+
 check_library_exists(${NETCDF_LIBRARY} nc_inq_path "" has_nc_inq_path)
 if (has_nc_inq_path)
   message("-- Found nc_inq_path in: " ${NETCDF_LIBRARY})
@@ -316,7 +322,3 @@
 if (UDUNITS2_LIBRARY AND UDUNITS2_INCLUDE)
   find_library(EXPAT_LIBRARY NAMES libexpatMT expat ${find_opt})
   if(NOT EXPAT_LIBRARY)
-    message("${color_magenta}-- Expat library not found${color_reset}")
-    message("-- Disabling UDUNITS support")
-  else()
-    message("-- Found Expat library at: " ${EXPAT_LIBRARY})

=== bld/Makefile ===
--- 
+++ 
@@ -14,15 +14,15 @@
 
 # Machine build parameters
 #                         Source     Method   Packages Compiler
-# aerosol.ess.uci.edu: NCO          Configure All else clang
+# aerosol.ess.uci.edu: NCO          Configure All else GCC
 # AppVeyor CI        : NCO          CMake     All else MSVC
 # cheyenne.ucar.edu  : NCO          Makefile  All else Intel
 # cooley.alcf.anl.g  : NCO          Configure All else GCC
 # edison.nersc.gov   : NCO          Configure All else Intel
-# firn.ess.uci.edu   : NCO          Configure All else clang
+# firn.ess.uci.edu   : NCO          Configure All else GCC
 # frazil.ess.uci.edu : NCO          Configure All else clang
 # glace.ess.uci.edu  : NCO          CMake     All else GCC
-# grele.ess.uci.edu  : NCO          Makefile  All else GCC
+# grele.ess.uci.edu  : NCO + netCDF Makefile  All else GCC
 # katabatic.ess.uci.e: NCO          CMake     All else clang
 # rhea.ccs.ornl.gov  : NCO          Makefile  All else GCC
 # skyglow.ess.uci.edu: NCO + netCDF Configure All else GCC
@@ -42,7 +42,7 @@
 # Usage (Compilation):
 # cd ~/nco/qt;qmake;make;cd -        # Qt
 # cd ~/nco/bld;make;cd -             # Default build
-# cd ~/nco/bld;make USR_TKN='-DNC_HAVE_RENAME_GRP';cd - # New API
+# cd ~/nco/bld;make USR_TKN='-DHAVE_NC_RENAME_GRP';cd - # New API
 # cd ~/nco/bld;make UDUNITS_INC='/usr/include/udunits2';cd - # Fedora build
 # cd ~/nco/bld;make cln bin_cln;cd - # Clean all dependencies for fresh build
 # cd ~/nco/bld;make dir all; cd -    # Create target directories then build

=== debian/changelog ===
nco (4.7.6-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 17 Aug 2018 07:14:05 +0200

nco (4.7.6-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.0, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 12 Aug 2018 08:42:22 +0200

nco (4.7.5-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.5, no changes.
  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Aug 2018 07:20:48 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.1.4
+Standards-Version: 4.2.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
 Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.gi -b stretch-backportst
 Homepage: http://nco.sourceforge.net/

## nco 4.7.7

=== debian/changelog ===
nco (4.7.7-2) unstable; urgency=medium

  * Add upstream patch to fix FTBFS with NetCDF 4.6.2-RC1.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Sep 2018 16:21:57 +0200

nco (4.7.7-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file to limit matches to archive path.
  * Bump Standards-Version to 4.2.1, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Sep 2018 08:45:41 +0200

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/\-/\./g,\
filenamemangle=s/(?:.*?\/)?(?:rel|v|nco)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/nco-$1.$2/ \
https://github.com/nco/nco/releases \
(?:.*?/archive/)?(?:rel|v|nco)?[\-\_]?(\d[\d\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## nco 4.7.8

=== debian/changelog ===
nco (4.7.8-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches, included upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 17 Nov 2018 07:48:48 +0100

=== debian/control ===
--- 
+++ 
@@ -18,9 +18,9 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
-Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.gi -b stretch-backportst
+Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git
 Homepage: http://nco.sourceforge.net/
 
 Package: nco

## nco 4.7.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -204,7 +204,7 @@
   add_definitions(-DHAVE_NETCDF_MEM_H)
   message("-- NetCDF diskless functionaliy enabled")
 else()
-  message("-- NetCDF diskless functionaliy not available, netcdf_mem.h or nc_open_mem not found")
+  message("-- NetCDF diskless functionaliy not available, netcdf_mem.h or nc_open_mem() not found")
 endif()
 
 #if nc_def_var_filter() is available, nc_inq_path(), nc_inq_format() and has_nc_open_mem() are too

=== bld/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Purpose: GNU Makefile for NCO module nco
 # Requires GNU Make---AT&T Make chokes on GNU syntax
 
-# Copyright (C) 1994--2018 Charlie Zender
+# Copyright (C) 1994--present Charlie Zender
 # License: GNU General Public License (GPL) Version 3
 # See http://www.gnu.org/copyleft/gpl.html for full license text

=== debian/changelog ===
nco (4.7.9-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 03 Mar 2019 08:31:28 +0100

nco (4.7.9-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.3.0, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 21 Feb 2019 06:59:59 +0100

nco (4.7.8-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 19 Dec 2018 08:24:40 +0100

nco (4.7.7-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 27 Sep 2018 07:25:53 +0200

=== debian/control ===
--- 
+++ 
@@ -18,9 +18,9 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
-Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git -b stretch-backports
 Homepage: http://nco.sourceforge.net/
 
 Package: nco

## nco 4.8.1

=== debian/changelog ===
nco (4.8.1-1) unstable; urgency=medium

  * Update gbp.conf to use --source-only-changes by default.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 07 Jul 2019 08:47:09 +0200

nco (4.8.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Remove package name from lintian overrides.
  * Add license & copyright for sources by Joseph O'Rourke.
  * Update copyright file, changes:
    - Update copyright years for Charlie Zender
    - Add license & copyright for nco_crt.h
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 02 Jul 2019 06:17:16 +0200

## nco 4.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -170,25 +170,19 @@
 endif()
 
 #/////////////////////////////////////////////////////////////////////////////////////
-#netCDF 4.6.0 
-#nc_def_var_filter , has_inq_var_filter, define NC_LIB_VERSION=460 if both found 
-#/////////////////////////////////////////////////////////////////////////////////////
-
-check_library_exists(${NETCDF_LIBRARY} nc_def_var_filter "" has_nc_def_var_filter)
-if (has_nc_def_var_filter)
-  message("-- Found nc_def_var_filter in: " ${NETCDF_LIBRARY})
-  add_definitions(-DHAVE_NC_DEF_VAR_FILTER)
-endif()
-
-check_library_exists(${NETCDF_LIBRARY} nc_inq_var_filter "" has_inq_var_filter)
-if (has_inq_var_filter)
-  message("-- Found has_inq_var_filter in: " ${NETCDF_LIBRARY})
-  add_definitions(-DHAVE_NC_INQ_VAR_FILTER)
-endif()
-
-if (has_nc_def_var_filter AND has_inq_var_filter)
-  add_definitions(-DNC_LIB_VERSION=460)
-endif ()
+#netcdf_meta.h defines NC_VERSION_MAJOR NC_VERSION_MINOR NC_VERSION_PATCH 
+#NCO defines NC_LIB_VERSION ( NC_VERSION_MAJOR * 100 + NC_VERSION_MINOR * 10 + NC_VERSION_PATCH ) 
+#/////////////////////////////////////////////////////////////////////////////////////
+
+find_path(path_netcdf_meta_h netcdf_meta.h PATHS ${NETCDF_INCLUDE})
+if(path_netcdf_meta_h)
+  message("-- Found netcdf_meta.h in " ${path_netcdf_meta_h})
+  add_definitions(-DNC_HAVE_META_H)
+else()
+  message("-- netcdf_meta.h was not found; defining NC_LIB_VERSION=360")
+  add_definitions(-DNC_LIB_VERSION=360)
+endif()
+
 
 find_path(path_netcdf_mem_h netcdf_mem.h PATHS ${NETCDF_INCLUDE})
 if (path_netcdf_mem_h)
@@ -322,3 +316,6 @@
 if (UDUNITS2_LIBRARY AND UDUNITS2_INCLUDE)
   find_library(EXPAT_LIBRARY NAMES libexpatMT expat ${find_opt})
   if(NOT EXPAT_LIBRARY)
+    message("${color_magenta}-- Expat library not found${color_reset}")
+    message("-- Disabling UDUNITS support")
+  else()

=== debian/changelog ===
nco (4.9.1-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:20:36 +0100

nco (4.9.1-1build1) focal; urgency=medium

  * No-change rebuild for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jan 2020 18:02:03 +0100

nco (4.9.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop Name field from upstream metadata.
  * Add lintian override for manpage-without-executable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Dec 2019 07:04:03 +0100

nco (4.9.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.4.1, no changes.
  * Drop spelling-errors.patch, applied upstream.
  * Drop unused override for spelling-error-in-binary.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 05 Dec 2019 05:32:58 +0100

=== debian/control ===
--- 
+++ 
@@ -18,9 +18,9 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
-Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git -b stretch-backports
+Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git
 Homepage: http://nco.sourceforge.net/
 
 Package: nco

=== debian/rules ===
#!/usr/bin/make -f

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Use custom automake command to prevent autoreconf failure
export AUTOMAKE = ./debian/automake.sh

%:
	dh $@ --with autoreconf \
	      --buildsystem autoconf \
	      --parallel

override_dh_clean:
	dh_clean data/big.nc \
	         data/in_1.nc \
	         data/in_2.nc \
	         data/nco_bm.stderr \
	         debian/rules.old \
	         doc/nco.info \
	         doc/nco.info-1 \
	         doc/nco.info-2 \
	         doc/nco.info-3

override_dh_auto_configure:
	dh_auto_configure -- \
		--libdir=/usr/lib/nco \
		--disable-nco_cplusplus \
		--disable-static \
		--disable-udunits \
		--enable-dap \
		--enable-gsl \
		--enable-ncap2 \
		--enable-netcdf4 \
		--enable-udunits2

override_dh_auto_build:
	dh_auto_build
	cd doc && $(MAKE) clean && $(MAKE) html
	cd doc && $(MAKE) nco.info && sed -i 's/xmp\/fgr[0-9].png/\/usr\/share\/doc\/nco\/&/' nco.info*

override_dh_auto_test:
	# currently the check phase badly fails
	dh_auto_test || echo "Ignoring test failures"

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/nco -name '*.h' -delete
	find $(CURDIR)/debian/nco -name '*.hh' -delete
	$(RM) debian/nco/usr/lib/nco/libnco.la
	$(RM) debian/nco/usr/share/info/dir

override_dh_install:
	dh_install --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/nco

## nco 4.9.3

=== debian/changelog ===
nco (4.9.3-1build1) groovy; urgency=medium

  * Rebuild against new glibc 2.32.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Sep 2020 22:05:12 +0200

nco (4.9.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.0, no changes.
  * Update copyright file, changes:
    - NCO license changes to BSD-3-Clause.
    - nco_gsl.* is no longer dual licensed
  * Bump debhelper compat to 10, changes:
    - Drop --parallel option, enabled by default
    - Don't explicitly enable autoreconf, enabled by default
    - Drop dh-autoreconf build dependency

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 01 Jun 2020 05:47:32 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,7 @@
            Bas Couwenberg <sebastic@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
-               dh-autoreconf,
-               autotools-dev,
+Build-Depends: debhelper (>= 10~),
                bison,
                flex,
                antlr,
@@ -18,7 +16,7 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/nco
 Vcs-Git: https://salsa.debian.org/debian-gis-team/nco.git
 Homepage: http://nco.sourceforge.net/

## nco 4.9.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -183,7 +183,6 @@
   add_definitions(-DNC_LIB_VERSION=360)
 endif()
 
-
 find_path(path_netcdf_mem_h netcdf_mem.h PATHS ${NETCDF_INCLUDE})
 if (path_netcdf_mem_h)
   message("-- Found netcdf_mem.h in: " ${path_netcdf_mem_h})
@@ -282,40 +281,36 @@
   message("-- Found curl library at: " ${CURL_LIBRARY})
 endif()
 
-#//////////////////////////
-#detect optional dependencies
-#//////////////////////////
-
-#//////////////////////////
-# UDUNITS2 (and EXPAT)
-# Add non standard UDUNITS2 header paths (Mac ports, Linux Fedora)
-#//////////////////////////
-
-set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH})
-set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} "/opt/local/include/udunits2")
-set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} "/usr/include/udunits2")
-
-find_path(UDUNITS2_INCLUDE udunits2.h ${find_opt})
-if(NOT UDUNITS2_INCLUDE)
-  message("${color_magenta}-- Unidata units library header files not found${color_reset}")
-else()
-  message("-- Found Unidata units library header files at: " ${UDUNITS2_INCLUDE})
-endif()
-
-find_library(UDUNITS2_LIBRARY NAMES udunits2 ${find_opt})
-if(NOT UDUNITS2_LIBRARY)
-  message("${color_magenta}-- Unidata units library not found${color_reset}")
-else()
-  message("-- Found Unidata units library at: " ${UDUNITS2_LIBRARY})
-endif()
-
-#//////////////////////////
-# UDUnits depends on expat
-#//////////////////////////
-
-if (UDUNITS2_LIBRARY AND UDUNITS2_INCLUDE)
-  find_library(EXPAT_LIBRARY NAMES libexpatMT expat ${find_opt})
-  if(NOT EXPAT_LIBRARY)
-    message("${color_magenta}-- Expat library not found${color_reset}")
-    message("-- Disabling UDUNITS support")
-  else()
+
+#//////////////////////////
+#GSL_ROOT
+#detect a user defined system environment variable GSL_ROOT
+#this sets the include path to GSL_INCLUDE directly
+#and a PATHS hint for GSL_LIBRARY and GSL_CBLAS_LIBRARY
+#For this case find_library(GSL_LIBRARY/GSL_CBLAS_LIBRARY) MUST be called 2 times
+#First time it looks in GSL_LIBRARY_PATH if set, avoiding all other PATHS with NO_DEFAULT_PATH
+#//////////////////////////
+
+set(gsl_root "$ENV{GSL_ROOT}")
+if(gsl_root)
+  set(GSL_INCLUDE "${gsl_root}/include")
+  set(GSL_LIBRARY_PATH "${gsl_root}/lib")
+  set(GSL_CBLAS_LIBRARY_PATH "${gsl_root}/lib")
+  message("${color_blue}-- Using user defined GSL location: ${gsl_root}${color_reset}")
+  set(GSL_CONFIG_PATH ${gsl_root}/bin/gsl-config)
+endif(gsl_root)
+  
+#//////////////////////////
+#find gsl-config
+#//////////////////////////  
+  
+find_program(gsl_config NAMES gsl-config PATHS ${GSL_CONFIG_PATH} NO_DEFAULT_PATH)
+find_program(gsl_config NAMES gsl-config ${find_opt})
+
+if (gsl_config)
+  execute_process(COMMAND ${gsl_config} --prefix OUTPUT_VARIABLE gsl_prefix)
+  if (gsl_prefix)
+    string(REGEX REPLACE "\n$" "" gsl_prefix "${gsl_prefix}")
+    message("${color_blue}-- Found GSL installation prefix at ${gsl_prefix}${color_reset}")
+  endif(gsl_prefix)
+  execute_process(COMMAND ${gsl_config} --version OUTPUT_VARIABLE gsl_version)

=== bld/Makefile ===
--- 
+++ 
@@ -4,11 +4,12 @@
 # Requires GNU Make---AT&T Make chokes on GNU syntax
 
 # Copyright (C) 1994--present Charlie Zender
-# License: GNU General Public License (GPL) Version 3
-# See http://www.gnu.org/copyleft/gpl.html for full license text
+# License: 3-Clause BSD License
+# See https://opensource.org/licenses/BSD-3-Clause for full license text
 
 # Quickie test copies:
 # scp ~/nco/bld/Makefile dust.ess.uci.edu:nco/bld
+# scp ~/nco/bld/Makefile grele.ess.uci.edu:nco/bld
 # scp ~/nco/bld/Makefile gplogin2.ps.uci.edu:nco/bld
 # scp ~/nco/bld/Makefile skyglow.ess.uci.edu:nco/bld
 
@@ -238,4 +239,3 @@
 else # endelse LIB_NCAR
  NETCDF_LIB := ${NETCDF_ROOT}/lib # Directory containing libnetcdf.a
 endif # endif LIB_NCAR
-endif # endif NETCDF_LIB

=== debian/changelog ===
nco (4.9.5-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright years for Charlie Zender.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 24 Sep 2020 06:13:33 +0200

nco (4.9.4-1) unstable; urgency=medium

  * New upstream release.
  * Drop UNRELEASED changelog entries.
  * Update lintian overrides for renamed tags.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 05 Sep 2020 07:04:06 +0200

## nco 4.9.6

=== debian/changelog ===
nco (4.9.6-1) unstable; urgency=medium

  * New upstream release.
  * Bump watch file version to 4.
  * Bump Standards-Version to 4.5.1, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 01 Dec 2020 05:56:38 +0100
